

library(magrittr)

rm(list=ls())

fold<- 'confronto_G25-50'
variabile<- 'hist1'
theta<- c(1:4,NA)
tabella<- data.frame(sigma=numeric(),G=numeric(),method=character(),stat=numeric())


statistica<- function(obj,nome,theta,ce=FALSE)
{
	p<- 1:length(theta)
	if (ce) { p<- p*2-1}
	if (nome=='hist1') { obj$estimate[p][1] ->out }
	if (nome=='hist2') { obj$estimate[p][2] ->out }
	if (nome=='hist3') { obj$estimate[p][3] ->out }
	if (nome=='hist4') { obj$estimate[p][4] ->out }
	if (nome=='hist5') { obj$estimate[p][5] ->out }
	
	out
}

for (subfold in dir(fold))
{
	paste0(fold,'/',subfold) %>% dir -> filen
	filen %>% substr(1,6) %>% {which(.=='piano_')} %>% filen[.] %>% paste0(fold,'/',subfold,'/',.) -> filen
	load(filen)
	piano$.layer<- which(subfold==dir(fold))
	piano$.z<- NA
	
	for (j in 1:nrow(piano))
	{
		load(paste0(fold,'/',subfold,'/',piano$nomef[j],'.RData'))
		theta[5]<- piano$sigma[j]
		AGQ1   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature (m=1)   ',stat=.)} %>% rbind(tabella,.) ->tabella
		AGQ3   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature (m=3)   ',stat=.)} %>% rbind(tabella,.) ->tabella
		AGQ5   %>% statistica(variabile,theta,FALSE) %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='AG quadrature (m=5)   ',stat=.)} %>% rbind(tabella,.) ->tabella
		ce1000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy (N=1000)',stat=.)} %>% rbind(tabella,.) ->tabella
		ce2000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy (N=2000)',stat=.)} %>% rbind(tabella,.) ->tabella
		ce5000 %>% statistica(variabile,theta,TRUE)  %>% {data.frame(sigma=piano$sigma[j],G=piano$G[j],method='Cross-entropy (N=5000)',stat=.)} %>% rbind(tabella,.) ->tabella
	}
}

save(tabella,theta,file=paste0('distribuzioni/',variabile,'.RData'))







